<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Managers\DecisionPolls\DecisionPollsManager;
use App\Managers\Decision\DecisionManager;
use App\Managers\TacticSuggestions\TacticSuggestionsManager;
use App\Managers\Proposal\ProposalManager;
use App\Managers\LiveProposal\LiveProposalManager;
use Illuminate\Support\Facades\DB;

class ArchiveController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->decisionPolls = new DecisionPollsManager();
        $this->decisionManager = new DecisionManager();
        $this->tacticSuggestionManager = new TacticSuggestionsManager();
        $this->proposalManager = new ProposalManager();
        $this->liveProposalManager = new LiveProposalManager();
    }
    
    public function decisionPoll(Request $request)
    {
    	$polls = $this->decisionPolls->select('*',DB::raw('DATE_FORMAT(expiry_date, "%d %b %Y %H:%i") AS formatted_expiry_date'))
            ->withCount('options')
            ->with(['options'=>function($q){
               $q->withCount(
                [
                    'votesCount AS total_votes' => function ($query) {
                                $query->select(DB::raw("SUM(votes) as total_votes"));
                            }
                        ]

                );
            }])
       // ->withCount('options.votesCount')
        ->orderBy('created_at', 'DESC')->get();
        //dd($polls[0]);
        return view('archive/decisionPoll')->with('polls', $polls);
    }

    public function decisionProposal(Request $request)
    {
    	 $decisions = $this->decisionManager->orderBy('created_at', 'DESC')->paginate(config('settings.no_of_records'));
        return view('archive/decisionProposal')->with('decisions', $decisions);
    }

    public function tacticProposal(Request $request)
    {
    	$decisions = $this->tacticSuggestionManager->with('user')->select(DB::raw('count(tactic_suggestion_like_count.no_of_likes) as no_of_likes, tactic_suggestions.*'))->leftJoin('tactic_suggestion_like_count', 'tactic_suggestions.UUID', '=', 'tactic_suggestion_like_count.tactic_suggestion_id')->groupBy('tactic_suggestions.UUID')->orderBy('tactic_suggestions.created_at', 'DESC')->paginate(config('settings.no_of_records'));
        return view('archive/tacticProposal')->with('decisions', $decisions);
    }

    public function playerProposal(Request $request)
    {
    	$decisions = $this->proposalManager->with('user')->select(DB::raw('count(proposal_like_count.no_of_likes) as likes_count, proposal.*'))->leftJoin('proposal_like_count', 'proposal.UUID', '=', 'proposal_like_count.proposal_id')->groupBy('proposal.UUID')->orderBy('proposal.created_at', 'DESC')->paginate(config('settings.no_of_records'));
        
         return view('archive/playerProposal')->with('decisions', $decisions);
    }

    public function liveProposal()
    {
    	$decisions = $this->liveProposalManager->with('user')->select(DB::raw('count(live_proposal_like_count.no_of_likes) as likes_count, live_proposal.*'))->leftJoin('live_proposal_like_count', 'live_proposal_like_count.live_proposal_id', '=', 'live_proposal.UUID')->groupBy('live_proposal.UUID')->orderBy('live_proposal.created_at', 'DESC')->paginate(config('settings.no_of_records'));
        return view('archive/liveProposal')->with('decisions', $decisions);
    }
}