<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreatePaypalTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('paypal', function (Blueprint $table) {
            $table->bigIncrements('id')->unsigned();
            $table->uuid('UUID');
            $table->decimal('mc_gross', 18, 2)->default(0.00);
            $table->string('protection_eligibility')->nullable();
            $table->string('address_status')->nullable();
            $table->string('payer_id')->nullable();
            $table->decimal('tax', 18, 2)->default(0.00);
            $table->string('address_street')->nullable();
            $table->string('payment_date')->nullable();
            $table->string('payment_status', 18, 2)->nullable();
            $table->string('charset')->nullable();
            $table->string('address_zip')->nullable();
            $table->string('first_name')->nullable();
            $table->decimal('mc_fee', 18, 2)->default(0.00);
            $table->string('address_country_code')->nullable();
            $table->string('address_name')->nullable();
            $table->string('notify_version')->nullable();
            $table->string('custom')->nullable();
            $table->string('payer_status')->nullable();
            $table->string('business')->nullable();
            $table->string('address_country')->nullable();
            $table->string('address_city')->nullable();
            $table->bigInteger('quantity')->nullable();
            $table->string('verify_sign')->nullable();
            $table->string('payer_email')->anullable();
            $table->string('txn_id')->nullable();
            $table->string('payment_type')->nullable();
            $table->string('payer_business_name')->nullable();
            $table->string('last_name')->nullable();
            $table->string('address_state')->nullable();
            $table->string('receiver_email')->nullable();
            $table->decimal('payment_fee', 18, 2)->default(0.00);
            $table->string('receiver_id')->nullable();
            $table->string('txn_type')->nullable();
            $table->string('item_name')->nullable();
            $table->string('mc_currency')->nullable();
            $table->string('item_number')->nullable();
            $table->string('residence_country')->nullable();
            $table->string('test_ipn')->nullable();
            $table->string('transaction_subject')->nullable();
            $table->decimal('payment_gross', 18, 2)->default(0.00);
            $table->string('ipn_track_id')->nullable();
            $table->string('memo')->nullable();
            $table->string('type')->nullable();
            $table->uuid('user_id');
            
            $table->timestamps();
            $table->softDeletes();
            
            $table->foreign('user_id')->references('UUID')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('paypal');
    }
}
